#ifndef REF_H
#define REF_H

#include <flex/flex.h>
/*
 * No description
 */
namespace Flex {
  class Var;
  class Ref {
    Value * value;
    int index;
    char * key;
    Value * GetValue() const;
    void SetValue(Value * value);
  	public:
      Ref();
  		Ref(Value * value, int index);
  		Ref(Value * value, const char * key);
  		~Ref();
  		
  		// Var imitation
  		FlexType::Type Type();
  		Ref operator[](int index);
  		Ref operator[](const char * key);
  		void Push(const Var & var);
  		void Push(const Ref & ref);
  		void Push(Value * value);
  		void Push(const char * s);
  		void Push(int i);
  		void Push(double f);
  		void Push(bool b);
  		int Length();
  		Var Keys();
  		char * ToString();
  		bool ToBoolean();
  		int ToInt();
  		double ToFloat();
  		Value * Clone() const;
  		
  		// Type casting
  		Ref & operator=(const Var & var);
  		Ref & operator=(const Ref & ref);
  		Ref & operator=(Value * v);
  		Ref & operator=(const char * s);
  		Ref & operator=(int i);
  		Ref & operator=(double f);
  		Ref & operator=(bool b);
  };
};

#endif
