#ifndef VAR_H
#define VAR_H

#include <flex/flex.h>

/*
 * No description
 */
namespace Flex {
  class Ref;
  class Var {
    Value * value;
    static Value * undefined;
  	public:
  		Var();
  		Var(const Var & var);
  		Var(const Ref & ref);
  		Var(Value * value);
  		~Var();

  		FlexType::Type Type();
  		Ref operator[](int index);
  		Ref operator[](const char * key);
  		void Push(const Var & var);
  		void Push(const Ref & ref);
  		void Push(Value * value);
  		void Push(const char * s);
  		void Push(int i);
  		void Push(double f);
  		void Push(bool b);
  		int Length();
  		Var Keys();
  		char * ToString();
  		bool ToBoolean();
  		int ToInt();
  		double ToFloat();
  		Value * Clone() const;
  		
  		// Type casting
  		Var & operator=(const Var & var);
  		Var & operator=(const Ref & ref);
  		Var & operator=(Value * v);
  		Var & operator=(const char * s);
  		Var & operator=(int i);
  		Var & operator=(double f);
  		Var & operator=(bool b);
  };
};

#endif
